(function main(){

    model.results = [];
    var baseUrl = getBaseUrl();
    var nodeRefString = args.fieldData;
    var node = search.findNode(nodeRefString);

    if (!node) {
        logger.log("Unable to find a Node[" + nodeRefString + "].");
        return;
    }

    var associations = node.assocs["rs:jiraIssueAssociation"];

    if (!associations || !associations.length) {
        logger.log("Unable to find an Associations[rs:jiraIssueAssociation] of Node[" + nodeRefString + "].");
        return;
    }

    for (var i = 0; i < associations.length; i++) {
        var associationNodeRefString = associations[i].nodeRef;
        var item = search.findNode(associationNodeRefString);
        var issueKey = item.properties["rs:jiraIssueKey"];
        var issueId = item.properties["rs:jiraIssueId"];
        var issueType = item.properties["rs:jiraIssueType"];
        var jiraUri = null;
        if(baseUrl != null){
            jiraUri = baseUrl + "/browse/" + issueKey;
        }
        logger.log("Jira Issue :" + issueKey + ", Issue Type :" + issueType);
        model.results.push({
            issueKey: issueKey,
            issueId: issueId,
            issueType: issueType,
            jiraUri : jiraUri
        });
    }

    function getBaseUrl() {

        // Jira Server 設定ファイルの場所
        var configFilePath = "/app:company_home/app:dictionary/cm:Ricksoft/cm:Atlassian/cm:Jira";

        // 設定ファイルの取得
        try{
            var configNode = companyhome.childrenByXPath(configFilePath)[0].getChildAssocsByType("rs:jiraServer")[0];
        } catch (error){
            logger.log("Jira Server configuration file was not found.");
        }

        if(configNode != null){
            // 設定ファイルがある場合
            return configNode.properties["rs:jiraServerBaseUrl"];
        } else {
            logger.log("Jira Server configuration file was not found.");
        }

        return null;
    }

})();
